Frontend Utilities AddOn für REDAXO 4
====================================

Dieses REDAXO-AddOn dient als Container für PlugIns die das Frontend erweitern/ergänzen.
Es bietet eine Übersichtseite und für die PlugIns die Möglichkeit eigene Seiten, z.B. für
Einstellungen hinzuzufügen.

Es ist weitgehend eine Kopie des Addons Backend Utilities von RexDude

Features
--------

* Übersichtsseite mit allen installierten PlugIns
* Jedes PlugIn kann eine eigene Einstellungsseite haben
* Vereinfachte Einbindung der PlugIns möglich

Mitgelieferte PlugIns
---------------------

* `Tags` 
* `Kommentare` 


Vereinfachte Einbindung eines PlugIns
-------------------------------------

Ein PlugIn kann ganz einfach in der `config.inc.php` des PlugIns eingebunden werden:

```php
if ($REX['REDAXO']) { // only backend
	// register plugin
	rex_fe_plugin_factory::registerPlugin('fe_utilities', 'my_plugin', 'Mein Plugin', 'Eine kurze Beschreibung.', '1.0.0', 'Der Autor', 'forum.redaxo.de', /* $hasBackendPage = */ true, /* $permission = '' */);

	// ...
}
```

In der `help.inc.php` des PlugIns lässt sich der Beschreibungstext so anzeigen:

```php
// show plugin description
echo rex_fe_plugin_factory::getPluginDescription('fe_utilities', 'my_plugin');
```

Klassische Einbindung eines PlugIns
-----------------------------------

Alternativ lässt sich ein PlugIn auch wie gewohnt einbinden:

```php
if ($REX['REDAXO']) { // only backend
	// register plugin
	$REX['ADDON']['page']['my_plugin'] = 'Mein Plugin';
	$REX['ADDON']['version']['my_plugin'] = '1.0.0';
	$REX['ADDON']['author']['my_plugin'] = 'Der Autor';
	$REX['ADDON']['supportpage']['my_plugin'] = 'forum.redaxo.de';
	$REX['ADDON']['description']['my_plugin'] = 'Eine kurze Beschreibung.';

	// add sub page (if needed)
	$REX['ADDON']['fe_utilities']['SUBPAGES'][] = array('plugin.my_plugin', $REX['ADDON']['page']['my_plugin']);

	// ...
}
```

Und hier die Anzeige des Beschreibungstext für die `help.inc.php`:

```php
// show plugin description
echo OOPlugin::getProperty('fe_utilities', 'my_plugin', 'description');
```

Hinweise
--------

* Getestet mit REDAXO 4.4, 4.5
* AddOn-Ordner lautet: `fe_utilities`

Changelog
---------

siehe [CHANGELOG.md](CHANGELOG.md)

Lizenz
------

siehe [LICENSE.md](LICENSE.md)

