<?php

/**
 * easy_tags Klasse für Frontend und backend
 * 
 * Im Backend kann man damit von allen Artikeln die Keywords einlesen, die
 * dann als Tag's übernommen werden. Dabei werden 3 Arrays  in Dateien
 * gespeichert um im Frontend ohne DB-Zugriff verfügbar zu sein. 
 * 
 * Array TAG_MAP enthält alle Tag's als Key, Wert ist die Anzahl an Vorkommen.
 * Array TAG_LIST enthalt alle Tags als Key, darin ist wieder ein Array welches alle passenden Artikel-ID's enthält.
 * Array TAG_ARTS enthält alle Artikel-ID's als Key, darin ist ein Array mit allen Tag's
 * 
 * Per default werden alle Online-Artikel berücksichtigt
 *
 * @author      webghost 
 * @version     0.1.2 18/12/2013
 * @package     REDAXO 4.5
 */
class easyTags1135 {
    /*
     * 
     */

    // REX werte - werden mit Instanz geladen
    public $cache = ''; //pfad zum speicher
    public $count = 12; //anzahlt tags in cloud
    public $seo42 = '1'; // 1 oder 0 
    public $dbpfix = ''; // tabellen präfix
    public $listart = ''; // absoluter pfad zum artikel mit der ausgabe
    //interne werte
    public $tagrow = 'seo_keywords';
    public $tag_map_file = 'tag_map.arr';
    public $tag_list_file = 'tag_list.arr';
    public $tag_arts_file = 'tag_arts.arr';
    public $tag_cloud_file = 'tag_cloud.string';
    private $tag_list_sufix = '.list';
    //arrays 
    public $tag_map_arr = array();
    public $tag_list_arr = array();
    public $tag_arts_arr = array();
    
    public $tag_cloud_string = "";
    public $tag_list_formated = ""; 
    public $sql_query = "";
    private $sql_query_default = "SELECT id, ###tagrow###  FROM ###dbpfix###article
                                     WHERE status = '1'
                                ";
    private $start_timer = 0;
    private $metai = '';
    private $config_loadet = false;

    function easyTags1135() {
        /*
         *  
         */
        $this->get_rex();
    }

    public function getTagMap() {

        $this->tag_map_arr = $this->get_data($this->tag_map_file);

        return $this->tag_map_arr;
    }

    public function getTagList() {

        $this->tag_list_arr = $this->get_data($this->tag_list_file);

        return $this->tag_list_arr;
    }

    public function getTagArts() {

        $this->tag_arts_arr = $this->get_data($this->tag_arts_file);

        return $this->tag_arts_arr;
    }

    public function getTagCloud() {

        $this->tag_cloud_string = $this->get_data($this->tag_cloud_file);

        return $this->tag_cloud_string;
    }

    public function getTagListSite($tag) {

        $this->tag_list_formated = $this->get_data($tag . $this->tag_list_sufix);

        return $this->tag_list_formated;
    }

    public function create_cache() {
        /*
         * liest die Tags aller Artikel aus und 
         * speichert drei Arrays
         * speichert eine fertige tagcloud
         */
        if ($this->config_loadet === false)
            $REX = $this->get_rex();

        $error = "";

        if ($this->seo42 === "0") {

            $this->tagrow = $this->metai;
        }

        if ($this->sql_query === "") {

            $sql_query = $this->get_sql_query();
        } else {

            $sql_query = $this->sql_query;
        }

        $sql = rex_sql::factory();
        #$sql->debugsql = 1; //Ausgabe Query
        $sql->setQuery($sql_query);

        $TAG_MAP = array(); //[TagName]=anzahl Vorkommen (int) - der key ist der Tagname und enthält als int wie oft er vorkommt
        $TAG_LIST = array(); //[TagName][]=Artikel-ID (string) - der key ist der Tagname und enthält ein array mit allen artikel-ids wo er vorkommt 
        $TAG_ARTS = array(); //[Artikel-ID][]=TAGNAMES (string) - der key ist die artikel-id und enthält ein array mit allen tagnamen zum artikel

        for ($i = 0; $i < $sql->getRows(); $i++) {

            $art_id = $sql->getValue('id'); //Artikel ID
            $tags = $sql->getValue($this->tagrow); // TAGS eines Artikels
            $tagarr = array(); //temp array

            if ($tags != '') {

                $tagarr = explode(',', $tags);

                foreach ($tagarr as $key => $tagname) {

                    $tagname = trim($tagname);
                    /*
                     * array key wird der tagname und der wert ist anzahl vorkommen für TagCloud
                     */
                    $tempcount = 0; //integer
                    $tempcount = $TAG_MAP[$tagname]; //wert auslesen
                    $TAG_MAP[$tagname] = $tempcount + 1; //wert +1 speichern

                    /*
                     * array key wird tagname und enthält ein array mit allen artikel-ids
                     */
                    $TAG_LIST[$tagname][] = $art_id;

                    /*
                     * array key wird artikel-id und enhält ein array mit allen tags zu diesem artikel
                     */
                    $TAG_ARTS[$art_id][] = $tagname;
                }//endforeach
            }//endif
            $sql->next();
        }//endfor

        /*
         * Arrays sortieren
         * 
         * TAG_MAP - absteigend nach anzahl vorkommen
         * TAG_LIST - absteigend nach artikel id
         * TAG_ARTS - belassen - reihenfolge wie in der Eingabe
         */
        arsort($TAG_MAP);

        foreach ($TAG_LIST as $key => $arr) {

            array_multisort($TAG_LIST[$key], SORT_DESC);
        }

        /*
         * alle arrays fertig - speichern
         */
        if ($this->save_to_file($TAG_MAP, $this->tag_map_file) !== true) {
            $error .= ' -1: Array $TAG_MAP konnte nicht gespeichert werden. ';
        }
        if ($this->save_to_file($TAG_LIST, $this->tag_list_file) !== true) {
            $error .= ' -2: Array $TAG_LIST konnte nicht gespeichert werden. ';
        }
        if ($this->save_to_file($TAG_ARTS, $this->tag_arts_file) !== true) {
            $error .= ' -3: Array $TAG_ARTS konnte nicht gespeichert werden. ';
        }

        if ($error !== "") {
            return $error;
        } else {
            return true;
        }
    }

    public function make_tag_cloud() {
        /*
         * macht aus den häufigsten Tags eine fertige TagCloud
         * 
         */
        if ($this->config_loadet === false)
            $REX = $this->get_rex();

        $arr = $this->getTagMap();
        
        $error = "";
        $tag = array();

        $i = 0;
        foreach ($arr as $key => $val) {
            if ($i === $this->count)
                continue;

            $tag[$i] = "\t" . '<a href="' . $this->listart . '?tag=' . $key . '" class="ETC' . $i . '">' . $key . '</a>' . "\n";

            $i++;
        }
        shuffle($tag); //mischen

        $out = '<div class="feu_easy_tags" id="TagCloud""">' . "\n";
        $out .= implode("", $tag);
        $out .= '</div>' . "\n";

        //tagcloud speichern
        if ($this->save_to_file($out, $this->tag_cloud_file) !== true) {
            $error .= ' -4: TagCloud konnte nicht gespeichert werden. ';
        }

        if ($error !== "") {
            return $error;
        } else {
            return true;
        }
    }

    public function make_tag_list() {
        /*
         * speichert je tag eine Artikelliste in eine datei
         */
        if ($this->config_loadet === false)
            $REX = $this->get_rex();

        $error = "";
        $tagname = "";
        $arr = $this->getTagList();

        foreach ($arr as $tagname => $array) {

            $out = "";
            $out .= "\n" . '<div class="feu_easy_tags" id="TagList">' . "\n";
            $out .= "\t" . '<h2>' . $tagname . '</h2>' . "\n";

            foreach ($array as $article_id) {

                $art = OOArticle::getArticleById($article_id);

                $title = "Titel nicht verfügbar";
                $description = "Beschreibung nicht verfügbar";
                $url = $art->getUrl();

                if ($art->getValue('seo_title') != "") {

                    $title = $art->getValue('seo_title');
                } elseif ($art->getValue('name') != "") {

                    $title = $art->getValue('name');
                }

                if ($art->getValue('seo_description') != "") {

                    $title = $art->getValue('seo_description');
                } elseif ($art->getValue('art_description') != "") {

                    $title = $art->getValue('art_description');
                }

                $out .= "\t" . '<div class="feu_easy_tags" id="TagArt">' . "\n";
                $out .= "\t\t" . '<h3><a href="' . $url . '">' . $title . '</a></h3>' . "\n";
                $out .= "\t\t" . '<p>' . $description . '</p>' . "\n";
                $out .= "\t\t" . '<small><a href="' . $url . '">...weiter</a></small>' . "\n";
                $out .= "\t" . '</div>' . "\n<!--###BreakPoint###-->\n";
            }

            $out .= '</div>' . "";

            if ($this->save_to_file($out, $tagname . $this->tag_list_sufix) !== true) {
                $error .= ' -5: TagList "' . $tagname . '" konnte nicht gespeichert werden. ';
            }
        }

        if ($error !== "") {
            return $error;
        } else {
            return true;
        }
    }

    private function get_data($file) {
        /*
         * gibt daten aus dem speicher zurück
         */
        $data = file_get_contents($this->cache . $file);

        $data = unserialize($data);

        return $data;
    }

    private function save_to_file($content, $file) {
        /*
         * speichert daten in eine datei auch arrays
         */
        $file = $this->cache . $file;

        $data = serialize($content);

        if (file_put_contents($file, $data) != false) {

            return true;
        } else {
            return false;
        }
    }

    private function get_sql_query() {
        /*
         * standart query laden
         */
        $sql_query = $this->sql_query_default;

        $sql_query = str_replace("###tagrow###", $this->tagrow, $sql_query);
        $sql_query = str_replace("###dbpfix###", $this->dbpfix, $sql_query);

        return $sql_query;
    }

    private function get_rex() {
        /*
         * holt das array $REX
         */
        global $REX;

        $this->cache = $REX['ADDON']['fe_utilities']['SETTINGS']['feu_easy_tags']['cache_path'];
        $this->count = $REX['ADDON']['fe_utilities']['SETTINGS']['feu_easy_tags']['tag_count'];
        $this->seo42 = $REX['ADDON']['fe_utilities']['SETTINGS']['feu_easy_tags']['seo42'];
        $this->metai = 'art_' . $REX['ADDON']['fe_utilities']['SETTINGS']['feu_easy_tags']['metainfo'];
        $this->listart = $REX['ADDON']['fe_utilities']['SETTINGS']['feu_easy_tags']['tag_path'];
        $this->dbpfix = $REX['TABLE_PREFIX'];

        $this->config_loadet = true;

        return $REX;
    }

    public function start_time() {
        // Zeit messen
        $time = explode(' ', microtime());
        $start_timer = ($time[0] + $time[1]);

        $this->start_timer = $start_timer;
    }

    public function stop_time() {
        // Zeit ermitteln
        $time = explode(' ', microtime());
        $stoptimer = ($time[0] + $time[1]);
        $timer = intval(($stoptimer - $this->start_timer) * 10000) / 10000;

        return $timer;
    }

}