<?php
/**
 * Layout top und bottom wird bereits eingebunden
 */
$basedir = dirname(__FILE__);
$page = rex_request('page', 'string');
$subpage = rex_request('subpage', 'string');
$func = rex_request('func', 'string');
/*
 * 
 * 
 */
?>

<div class="rex-addon-output">
    <h3 class="rex-hl2">Hier noch einige Beispiele</h3>
    <div class="rex-area-content">
        <p class="fe_utilities_slim">So könnte man easyTags in Templates oder Modulen verwenden.</p>

        <h4>Ausgabe einer TagCloud</h4>
        <p class="fe_utilities_slim">
            Beispielsweise so kömmte man eine TagClod erstellen. Es gibt 
            bestimmt noch bessere Lösungen, doch jedenfalls hat man hier freie 
            Hand bei der Darstellung.
        </p>
        <div class="rex-code">
<?php
highlight_string('<?php
$tags = new easyTags1135();//Instanz

/*
 * Eventuell Konfiguration ändern
 */
$tags->count = 9; //Anzahl Einträge
$tags->listart = \'/test/tstartikel.html\'; //absoluter Pfad zur Zielseite welche die Artikel auflistet

$TAG_MAP = $tags->getTagMap();//array aufrufen

$i = 0;
foreach ($TAG_MAP as $key => $val) {
    if ($i === $tags->count)
        continue; //stop wenn anzahl erreicht

    $tag[$i] = \'<a href="\' . $tags->listart . \'?tag=\' . $key . \'" class="ETC\' . $i . \'">\' . $key . \'</a>\';

    $i++;
}
shuffle($tag); //Die sortierung entfernen

$out = \'<div class="feu_easy_tags">\';
$out .= implode("", $tag);
$out .= \'</div>\';

echo $out;
?>');
?>
        </div>



        <h4>Ausgabe der Zielseite/Artikelliste</h4>
        <p class="fe_utilities_slim">
            Auf diese Weise kann man eine Artikelliste für die Zielseite
            erstellen.
        </p>
        <div class="rex-code">
<?php
highlight_string('<?php
$tags = new easyTags1135(); //Instanz
/*
 * nehmen wir an der Aufruf erfolgt z.B. mit
 * /test/test.html?tag=MeinTag
 */
rex_request(\'tag\', \'string\');
$TAG_LIST = $tags->getTagList(); //Array laden

if (is_array($TAG_LIST[$tag])) {
    $arr = $TAG_LIST[$tag];

    $out = "";
    $out .= \'<div class = "feu_easy_tags">\';
    $out .= \'<h2>\' . $tag . \' < / h2>\';

    foreach ($arr as  $art_id) { //hier die einzelnen Artikel durchlaufen

        /*
         * weitere Infos zum Artikel holen
         */
        $art = OOArticle::getArticleById($art_id);

        $title = "Titel nicht verfügbar";
        $description = "Beschreibung nicht verfügbar";
        $url = $art->getUrl();

        /*
         * hier nehmen wir mal SEO42 Werte
         */
        if ($art->getValue(\'seo_title\') != "") {

            $title = $art->getValue(\'seo_title\');
        }

        if ($art->getValue(\'seo_description\') != "") {

            $title = $art->getValue(\'seo_description\');
        }

        $out .= \'<div class = "feu_easy_tags article">\';
        $out .= \'<h3><a href = "\' . $url . \'">\' . $title . \' < / a></h3>\';
        $out .= \'<p>\' . $description . \' < / p>\';
        $out .= \'<small><a href = "\' . $url . \'">...weiter</a></small>\';
    }
    $out .= \'</div>\';
    echo $out;
} else {
    echo "kein Tag mit dem Namen gefunden";
}
?>');
?>
        </div>
        <p class="fe_utilities_slim">
            Es kann also beliebig aufgebaut und formatiert werden.
        </p>

        <h4>Ausgabe der Artikel-Tags</h4>
        <p class="fe_utilities_slim">
            So könnte man die Tags zu einem bestimmten Artikel ausgeben.
            Natürlich geht das auch ohne easyTags, hier steht aber bereits 
            ein Array zur Verfügung.
        </p>
        <div class="rex-code">
<?php
highlight_string('<?php
$tags = new easyTags1135();//Instanz

$TAG_ARTS = $tags->getTagArts();//array aufrufen

$article_id = $this->getValue(\'article_id\'); // aktuelle ID

foreach ($TAG_ARTS[$article_id] as $tag) {
    
    echo \'<a href="\' . $tags->listart . \'?tag=\' . $tag. \'">\' . $tag . \'</a>\';
}
?>');
?>
        </div>
    </div>



</div>